diff -ur slackware64-current.2/source/a/aaa_base/aaa_base.SlackBuild slackware64-current.3/source/a/aaa_base/aaa_base.SlackBuild
--- slackware64-current.2/source/a/aaa_base/aaa_base.SlackBuild	2021-07-17 19:46:57.879947846 +0200
+++ slackware64-current.3/source/a/aaa_base/aaa_base.SlackBuild	2021-09-18 13:42:52.406871391 +0200
@@ -79,9 +79,14 @@
   echo "VERSION_CODENAME=stable" >> $PKG/etc/os-release
 fi
 
-# Add lib64 directories on x86_64:
-if [ "$ARCH" = "x86_64" ]; then
-  mkdir -p $PKG/lib64 $PKG/usr/lib64 $PKG/usr/local/lib64
+# Add lib64 directories on x86_64 and aarch64:
+if [ "$ARCH" = "x86_64" -o "$ARCH" = "aarch64" ]; then
+  LIBDIRSUFFIX="64"
+else
+  LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+fi
+if [ "$LIBDIRSUFFIX" != "" ]; then
+  mkdir -p $PKG/lib$LIBDIRSUFFIX $PKG/usr/lib$LIBDIRSUFFIX $PKG/usr/local/lib$LIBDIRSUFFIX
 fi
 
 # Build the package:
diff -ur slackware64-current.2/source/a/cpufrequtils/cpufrequtils.SlackBuild slackware64-current.3/source/a/cpufrequtils/cpufrequtils.SlackBuild
--- slackware64-current.2/source/a/cpufrequtils/cpufrequtils.SlackBuild	2021-02-13 06:31:50.074945733 +0100
+++ slackware64-current.3/source/a/cpufrequtils/cpufrequtils.SlackBuild	2021-09-18 13:42:52.486875429 +0200
@@ -76,6 +76,8 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+zcat $CWD/0001-Only-x86-has-cpuid-instruction.patch.gz | patch -p1
+
 # Build and install:
 make libdir=/usr/lib${LIBDIRSUFFIX} || exit 1
 make install libdir=/usr/lib${LIBDIRSUFFIX} DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/a/efivar/efivar.SlackBuild slackware64-current.3/source/a/efivar/efivar.SlackBuild
--- slackware64-current.2/source/a/efivar/efivar.SlackBuild	2021-03-13 20:11:05.646092497 +0100
+++ slackware64-current.3/source/a/efivar/efivar.SlackBuild	2021-09-18 13:42:52.646883505 +0200
@@ -78,6 +78,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Patch native march
+zcat $CWD/host_march.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/a/elogind/elogind.SlackBuild slackware64-current.3/source/a/elogind/elogind.SlackBuild
--- slackware64-current.2/source/a/elogind/elogind.SlackBuild	2021-09-15 21:42:41.116049529 +0200
+++ slackware64-current.3/source/a/elogind/elogind.SlackBuild	2021-09-18 13:42:52.716887039 +0200
@@ -79,6 +79,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Add new architectures (OpenRISC, LoongARCH, etc.)
+zcat $CWD/openrisc-loongarch.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/a/etc/etc.SlackBuild slackware64-current.3/source/a/etc/etc.SlackBuild
--- slackware64-current.2/source/a/etc/etc.SlackBuild	2021-09-15 21:42:41.116049529 +0200
+++ slackware64-current.3/source/a/etc/etc.SlackBuild	2021-09-18 13:42:52.716887039 +0200
@@ -55,8 +55,14 @@
 # Fix for ARCH:
 sed -i -e "s#/i586-slackware-linux#/${ARCH}-slackware-linux#" etc/ld.so.conf.new
 # Fix paths if lib64 is needed:
-if [ "$ARCH" = "x86_64" ]; then
-  sed -i -e "s#/lib#/lib64#" etc/ld.so.conf.new
+if [ "$ARCH" = "x86_64" -o "$ARCH" = "aarch64" ]; then
+  LIBDIRSUFFIX="64"
+else
+  LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+fi
+
+if [ "$LIBDIRSUFFIX" != "" ]; then
+  sed -i -e "s#/lib#/lib${LIBDIRSUFFIX}#" etc/ld.so.conf.new
 fi
 zcat $CWD/nsswitch.conf.gz > $PKG/etc/nsswitch.conf.new
 
diff -ur slackware64-current.2/source/a/grub/grub.SlackBuild slackware64-current.3/source/a/grub/grub.SlackBuild
--- slackware64-current.2/source/a/grub/grub.SlackBuild	2021-09-15 21:42:41.116049529 +0200
+++ slackware64-current.3/source/a/grub/grub.SlackBuild	2021-09-18 13:42:52.716887039 +0200
@@ -91,11 +91,23 @@
 rm -rf $PKG
 mkdir -p $TMP $PKG
 
+if [ "$ARCH" = "mips64el" ]
+then
+  # Preinstall unifont, needed for loongson
+  mkdir /usr/share/fonts/unifont
+  mkdir -p $PKG/usr/share/fonts/unifont
+  cp -p $CWD/unifont-*.pcf.gz /usr/share/fonts/unifont/unifont.pcf.gz
+  cp -p $CWD/unifont-*.pcf.gz $PKG/usr/share/fonts/unifont/unifont.pcf.gz
+fi
+
 cd $TMP
 rm -rf $PKGNAM-$VERSION
 tar xvf $CWD/$PKGNAM-$VERSION.tar.xz || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix missing non-mandatory fence.i instruction in riscv64:
+zcat $CWD/riscv64_fence.i_not_implemented.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/a/haveged/haveged.SlackBuild slackware64-current.3/source/a/haveged/haveged.SlackBuild
--- slackware64-current.2/source/a/haveged/haveged.SlackBuild	2021-10-02 08:48:59.022671049 -0000
+++ slackware64-current.3/source/a/haveged/haveged.SlackBuild	2023-06-16 16:57:35.763314459 -0000
@@ -68,6 +68,10 @@
 rm -rf $PKGNAM-$VERSION
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
+
+# Disable v9 assembler code for sparc 32-bit:
+zcat $CWD/disable_sparcv9_asm.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find -L . \
  \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
diff -ur slackware64-current.2/source/a/lrzip/lrzip.SlackBuild slackware64-current.3/source/a/lrzip/lrzip.SlackBuild
--- slackware64-current.2/source/a/lrzip/lrzip.SlackBuild	2021-02-17 20:23:56.793004089 +0100
+++ slackware64-current.3/source/a/lrzip/lrzip.SlackBuild	2021-09-18 13:42:52.876895115 +0200
@@ -46,13 +46,17 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
+ASM="--enable-asm=no" # Disable assembly code by default
+
 if [ "$ARCH" = "i586" ]; then
+  ASM="" # Enable assembly for x86
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
 elif [ "$ARCH" = "s390" ]; then
   SLKCFLAGS="-O2"
   LIBDIRSUFFIX=""
 elif [ "$ARCH" = "x86_64" ]; then
+  ASM="" # Enable assembly for x86
   SLKCFLAGS="-O2 -fPIC"
   LIBDIRSUFFIX="64"
 else
@@ -85,6 +89,7 @@
   --mandir=/usr/man \
   --docdir=/usr/doc/$PKGNAM-$VERSION \
   --disable-static \
+  $ASM \
   --build=$ARCH-slackware-linux || exit 1
 
 make $NUMJOBS || make || exit 1
diff -ur slackware64-current.2/source/a/pkgtools/pkgtools.SlackBuild slackware64-current.3/source/a/pkgtools/pkgtools.SlackBuild
--- slackware64-current.2/source/a/pkgtools/pkgtools.SlackBuild.orig	2021-05-21 18:31:34.831004514 +0200
+++ slackware64-current.3/source/a/pkgtools/pkgtools.SlackBuild	2021-10-09 16:30:38.613381584 +0200
@@ -20,6 +20,7 @@
 #  ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 # Set initial variables:
+PARCH="noarch"
 cd $(dirname $0) ; CWD=$(pwd)
 if [ "$TMP" = "" ]; then
   TMP=/tmp
@@ -29,7 +29,7 @@
 # the name of the created package would be, and then exit. This information
 # could be useful to other scripts.
 if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
-  echo "$PKGNAM-$VERSION-$ARCH-$BUILD.txz"
+  echo "$PKGNAM-$VERSION-$PARCH-$BUILD.txz"
   exit 0
 fi
 
@@ -89,6 +89,21 @@
   chmod 755 $PKG/var/lib/pkgtools/setup/setup.*
   # Add a link for makebootstick:
   ( cd $PKG/sbin ; ln -sf ../var/lib/pkgtools/setup/setup.80.make-bootdisk makebootstick )
+  # Make customized default configuration for xz in makepkg:
+  ( cd $PKG/sbin
+    if [ `readelf -h /usr/bin/readelf|grep -c 80386` -gt 0 ] ; then
+      # x86 do not set ARCH environment, force it
+      ARCH="i586"
+    fi
+    if [ "x$ARCH" != "x" ] ; then
+      # Single-thread consume less memory and compress better:
+      zcat $CWD/single_thread.diff.gz | patch -p0 --verbose || exit 1
+    fi
+    if [ "$ARCH" = "arm" -o "$ARCH" = "ppc" -o "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "or1k" -o "$ARCH" = "hppa" -o "$ARCH" = "sh4" -o "ARCH" = "sparc" -o "$ARCH" = "i586" ] ; then
+      # For small-systems, force the compression to -4 (5MB memory for decompression):
+      zcat $CWD/low_memory.diff.gz | patch -p0 --verbose || exit 1
+    fi
+  )
 )
 
 # Create the base directories (not really necessary, but doesn't hurt):
@@ -101,7 +112,7 @@
 
 # Build the package:
 cd $PKG
-makepkg -l y -c n $TMP/pkgtools-$VERSION-$ARCH-$BUILD.txz
+makepkg -l y -c n $TMP/pkgtools-$VERSION-$PARCH-$BUILD.txz
 
 echo
 echo "HEY -- did you remember to update the version numbers in the setup scripts?"
diff -ur slackware64-current.2/source/a/userspace-rcu/userspace-rcu.SlackBuild slackware64-current.3/source/a/userspace-rcu/userspace-rcu.SlackBuild
--- slackware64-current.2/source/a/userspace-rcu/userspace-rcu.SlackBuild.orig	2023-06-14 13:40:53.759525094 +0200
+++ slackware64-current.3/source/a/userspace-rcu/userspace-rcu.SlackBuild	2023-06-14 21:33:32.256133108 +0200
@@ -78,6 +78,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Add generic-gcc implementation for atomic operations on unknown architectures:
+zcat $CWD/unknown_architecture_gcc_generic.diff.gz | patch --verbose -p1 || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/ap/bc/bc.SlackBuild slackware64-current.3/source/ap/bc/bc.SlackBuild
--- slackware64-current.2/source/ap/bc/bc.SlackBuild	2021-02-13 06:31:52.671945590 +0100
+++ slackware64-current.3/source/ap/bc/bc.SlackBuild	2021-09-18 13:42:53.026902686 +0200
@@ -65,6 +65,10 @@
 tar xvf $CWD/${PKGNAM}-$VERSION.tar.xz || exit 1
 cd ${PKGNAM}-$VERSION || exit 1
 
+# On loongarch64 running fix-libmath_h from make raise an error:
+# introducing explict bash call
+sed -i 's/^ed/#!\/bin\/bash\ned/' bc/fix-libmath_h
+
 # Make sure ownerships and permissions are sane:
 chown -R root:root .
 find . \
diff -ur slackware64-current.2/source/ap/cdparanoia/cdparanoia.SlackBuild slackware64-current.3/source/ap/cdparanoia/cdparanoia.SlackBuild
--- slackware64-current.2/source/ap/cdparanoia/cdparanoia.SlackBuild	2021-02-13 06:31:52.671945590 +0100
+++ slackware64-current.3/source/ap/cdparanoia/cdparanoia.SlackBuild	2021-09-18 13:42:53.026902686 +0200
@@ -72,6 +72,10 @@
 # Patch for changes in cdda headers:
 zcat $CWD/cdparanoia-III-10.2_cdda_private.patch.gz | patch -p3 --verbose --backup --suffix=.orig || exit 1
 
+# Add AArch64 architecture (and new architectures):
+\cp /usr/share/libtool/build-aux/config.sub configure.sub
+\cp /usr/share/libtool/build-aux/config.guess configure.guess
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/ap/cdrtools/cdrtools.SlackBuild slackware64-current.3/source/ap/cdrtools/cdrtools.SlackBuild
--- slackware64-current.2/source/ap/cdrtools/cdrtools.SlackBuild	2021-02-13 06:31:52.716945587 +0100
+++ slackware64-current.3/source/ap/cdrtools/cdrtools.SlackBuild	2021-09-18 13:42:53.056904200 +0200
@@ -59,6 +59,10 @@
 rm -rf cdrtools-$(echo $VERSION | cut -f 1 -d a)
 tar xvf $CWD/cdrtools-$VERSION.tar.?z || exit 1
 cd cdrtools-$(echo $VERSION | cut -f 1 -d a) || exit 1
+
+# Add symlinks for riscv64:
+zcat $CWD/riscv64-support.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/ap/dmapi/dmapi.SlackBuild slackware64-current.3/source/ap/dmapi/dmapi.SlackBuild
--- slackware64-current.2/source/ap/dmapi/dmapi.SlackBuild	2021-02-13 06:31:52.897945577 +0100
+++ slackware64-current.3/source/ap/dmapi/dmapi.SlackBuild	2021-09-18 13:42:53.106906724 +0200
@@ -71,6 +71,10 @@
 # Thanks, Debian
 zcat $CWD/bug799162.patch.gz | patch -p1 --verbose || exit 1
 
+# AArch64 specific patch
+zcat $CWD/missing-sys_getdents.patch.gz | patch -p1 --verbose || exit 1
+
+
 # Make sure you have the same version of autoconf as the
 # developers did...  ;-)
 autoreconf -vif
diff -ur slackware64-current.2/source/ap/ghostscript/ghostscript.SlackBuild slackware64-current.3/source/ap/ghostscript/ghostscript.SlackBuild
--- slackware64-current.2/source/ap/ghostscript/ghostscript.SlackBuild	2022-09-20 14:28:06.207562315 +0200
+++ slackware64-current.3/source/ap/ghostscript/ghostscript.SlackBuild	2023-05-15 12:32:03.237565466 +0200
@@ -83,6 +83,9 @@
 # Remove unmaintained garbage:
 rm -rf freetype jpeg lcms2 libpng libtiff png tiff zlib
 
+# Disable NEON instruction for arm (TesserACT won't compile):
+zcat $CWD/disable_neon.diff.gz | patch -p1 --verbose || exit 1
+
 # Regenerate ./configure.  Needed if patched, or to prevent libtool mismatch.
 autoreconf --force --install
 ( cd jbig2dec ; autoreconf --force --install )
@@ -88,6 +88,11 @@
 ( cd jbig2dec ; autoreconf --force --install )
 ( cd ijs ; autoreconf --force --install )
 
+# Patch lcms2 and psi bundled libraries to correctly handle alignment on ARMv5 and SPARC 
+# (64bit load/store should be aligned on 8-byte boundary even if 32bit architectures):
+zcat $CWD/arm_unaligned_64bit_load-store.diff.gz | patch -p1 --verbose || exit 1
+zcat $CWD/arm_sparc_psi_align8.diff.gz | patch -p1 --verbose || exit 1
+
 # Make sure ownerships and permissions are sane:
 chown -R root:root .
 find . \
@@ -114,6 +114,7 @@
 
 # Configure:
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
diff -ur slackware64-current.2/source/ap/linuxdoc-tools/linuxdoc-tools.build slackware64-current.3/source/ap/linuxdoc-tools/linuxdoc-tools.build
--- slackware64-current.2/source/ap/linuxdoc-tools/linuxdoc-tools.build	2021-08-12 14:42:11.000000000 +0200
+++ slackware64-current.3/source/ap/linuxdoc-tools/linuxdoc-tools.build	2021-09-18 13:42:53.266914800 +0200
@@ -45,7 +45,11 @@
 
 # Determine the general CFLAGS for the known architectures:
 case $ARCH in
-  arm*)    export SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard -mtune=generic-armv7-a -mabi=aapcs-linux"
+  arm) export SLKCFLAGS="-O2 -march=armv5te -mfloat-abi=soft"
+           export LIBDIRSUFFIX=""
+           export HOSTTARGET="-gnueabi"
+           ;;
+  armv7hl) export SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard -mtune=generic-armv7-a -mabi=aapcs-linux"
            export LIBDIRSUFFIX=""
            export HOSTTARGET="-gnueabihf"
            ;;
diff -ur slackware64-current.2/source/ap/lxc/lxc.SlackBuild slackware64-current.3/source/ap/lxc/lxc.SlackBuild
--- slackware64-current.2/source/ap/lxc/lxc.SlackBuild	2021-08-09 20:04:20.644977839 +0200
+++ slackware64-current.3/source/ap/lxc/lxc.SlackBuild	2021-09-18 13:42:53.346918839 +0200
@@ -94,6 +94,12 @@
 # so we'll comment this next line out for now:
 #[ -x /usr/bin/python3 ] && export PYTHON=/usr/bin/python3 && python="--enable-python"
 
+if [[ "$ARCH" = "ppc" ]]
+then
+  # Use ld.bfd on ppc ("unsupported -mbss-plt code" with gold)
+  sed -i 's/fuse-ld=gold/fuse-ld=bfd/' configure
+fi
+
 # Configure:
 # lua is autodetected
 CFLAGS="$SLKCFLAGS" \
diff -ur slackware64-current.2/source/ap/mariadb/mariadb.SlackBuild slackware64-current.3/source/ap/mariadb/mariadb.SlackBuild
--- slackware64-current.2/source/ap/mariadb/mariadb.SlackBuild	2021-08-09 20:04:20.644977839 +0200
+++ slackware64-current.3/source/ap/mariadb/mariadb.SlackBuild	2023-05-22 13:42:53.346918839 +0200
@@ -109,6 +109,16 @@
 tar xvf $CWD/${PKGNAM}-$VERSION.tar.?z || exit 1
 cd ${PKGNAM}-$VERSION || exit 1
 
+# Disabling HTM instruction set for PowerPC64, since gcc is targeted 
+# for the most generic processor without HTM instruction set
+zcat $CWD/disable_htm_ppc64.diff.gz | patch -p1 --verbose || exit 1
+
+# Removing incorrect asm v9 instructions for sparc-v8:
+zcat $CWD/sparc_pre-v9.diff.gz | patch -p1 --verbose || exit 1
+
+# Remove incorrect MYSQL structure size test for (some) 32 bit platforms:
+zcat $CWD/disable_compile_time_test_size.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -106,7 +106,7 @@
 
 mkdir build
 cd build
-cmake \
+LDFLAGS="$SLKLDFLAGS" cmake \
   -DCMAKE_C_FLAGS="$SLKCFLAGS" \
   -DCMAKE_CXX_FLAGS="$SLKCFLAGS" \
   -DCMAKE_BUILD_TYPE=RelWithDebInfo \
@@ -214,6 +214,12 @@
     mv $PKG/lib/security $PKG/lib${LIBDIRSUFFIX}/security
     rmdir $PKG/lib 2> /dev/null
   fi
+elif [ -d $PKG/lib64/security ]; then
+  if [ ! "lib64" = "lib${LIBDIRSUFFIX}" ]; then
+    mkdir -p $PKG/lib${LIBDIRSUFFIX}
+    mv $PKG/lib64/security $PKG/lib${LIBDIRSUFFIX}/security
+    rmdir $PKG/lib64 2> /dev/null
+  fi
 fi
 
 # The ./configure option to omit this has gone away, so we'll omit it
diff -ur slackware64-current.2/source/ap/mpg123/mpg123.SlackBuild slackware64-current.3/source/ap/mpg123/mpg123.SlackBuild
--- slackware64-current.2/source/ap/mpg123/mpg123.SlackBuild	2021-03-24 04:49:35.709449607 +0100
+++ slackware64-current.3/source/ap/mpg123/mpg123.SlackBuild	2021-09-18 13:42:53.426922877 +0200
@@ -86,15 +86,25 @@
 # --with-cpu=i586		Use code optimized for i586 processors
 # --with-cpu=i586_dither	Use code optimized for i586 processors with dithering (noise shaping), adds 256K to binary size
 # --with-cpu=3dnow		Use code optimized for 3DNow processors
+# --with-cpu=3dnow_vintage	Use code optimized for older 3DNow processors (K6 family)
 # --with-cpu=3dnowext		Use code optimized for 3DNowExt processors (K6-3+, Athlon)
 # --with-cpu=3dnowext_alone	Really only 3DNowExt decoder, without 3DNow fallback for flexible rate
+# --with-cpu=3dnowext_vintage	Use code optimized for older extended 3DNow processors (like K6-III+)
 # --with-cpu=mmx		Use code optimized for MMX processors
 # --with-cpu=mmx_alone		Really only MMX decoder, without i586 fallback for flexible rate
 # --with-cpu=sse		Use code optimized for SSE processors
+# --with-cpu=sse_vintage	Use code optimized for older SSE processors (plain C DCT36)
 # --with-cpu=sse_alone		Really only SSE decoder, without i586 fallback for flexible rate
+# --with-cpu=avx		Use code optimized for x86-64 with AVX processors
 # --with-cpu=x86		Pack all x86 opts into one binary (excluding i486, including dither)
 # --with-cpu=x86-64		Use code optimized for x86-64 processors (AMD64 and Intel64, including dithered generic)
-# --with-cpu=arm_nofpu		Use code optimized for ARM processors with fixed point arithmetic (experimental)
+# --with-cpu=altivec		Use code optimized for Altivec processors (PowerPC G4 and G5)
+# --with-cpu=ppc_nofpu		Use code optimized for PowerPC processors with fixed point arithmetic
+# --with-cpu=neon		Use code optimized for ARM NEON SIMD engine (Cortex-A series)
+# --with-cpu=arm_fpu		Pack neon and generic[_dither] decoders, for ARM processors with FPU and/or NEON
+# --with-cpu=arm_nofpu		Use code optimized for ARM processors with fixed point arithmetic
+# --with-cpu=neon64		Use code optimized for AArch64 NEON SIMD engine
+# --with-cpu=aarch64		Pack neon64 and generic[_dither] decoders, for 64bit ARM processors
 
 rm -rf $PKG
 mkdir -p $PKG $TMP
diff -ur slackware64-current.2/source/d/binutils/binutils.SlackBuild slackware64-current.3/source/d/binutils/binutils.SlackBuild
--- slackware64-current.2/source/d/binutils/binutils.SlackBuild	2021-08-27 22:23:54.171206523 +0200
+++ slackware64-current.3/source/d/binutils/binutils.SlackBuild	2021-09-18 13:42:53.496926410 +0200
@@ -53,13 +53,17 @@
 # Set to ld.gold or ld.bfd:
 DEFAULT_LD=ld.bfd
 
+ENABLE_GOLD=${ENABLE_GOLD:-"yes"}
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+  ADDTARGET="i386-efi-pe,bpf-unknown-none,"
   # The config option below is currently needed to compile on x86:
   WERROR="--enable-werror=no"
   LIBDIRSUFFIX=""
 elif [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+  ADDTARGET="i386-efi-pe,bpf-unknown-none,"
   # The config option below is currently needed to compile on x86:
   WERROR="--enable-werror=no"
   LIBDIRSUFFIX=""
@@ -68,6 +72,7 @@
   LIBDIRSUFFIX=""
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -fPIC"
+  ADDTARGET="i386-efi-pe,bpf-unknown-none,"
   LIBDIRSUFFIX="64"
 elif [ "$ARCH" = "armv7hl" ]; then
   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
@@ -82,6 +87,12 @@
     *)    TARGET=$ARCH-slackware-linux ;;
 esac
 
+# Remove targets in mips since it does not compiles gold with it:
+case "$ARCH" in
+    mips*) ADDTARGET="" ;;
+    *)     ADDTARGET="--enable-targets=${ADDTARGET}$TARGET" ;;
+esac
+
 TMP=${TMP:-/tmp}
 PKG=$TMP/package-binutils
 
@@ -105,6 +116,12 @@
 # Don't check to see if "config.h" was included in the installed headers:
 zcat $CWD/patches/binutils-no-config-h-check.patch.gz | patch -p1 --verbose || exit 1
 
+# Change from error to warning when RWX in LOAD section detected:
+zcat $CWD/patches/binutils.rwx-warning.diff.gz | patch -p1 --verbose || exit 1
+
+# Enable 64bit time_t in 32bit system (disable it only on gprofng):
+zcat $CWD/patches/enable_time64_on_32bit.diff.gz | patch -p1 --verbose || exit 1
+
 # Set %version to something halfway meaningful:
 zcat $CWD/patches/binutils-version.patch.gz | patch -p1 --verbose || exit 1
 sed -i -e 's/%''{release}/slack151/g' bfd/Makefile{.am,.in}
@@ -158,7 +172,9 @@
 fi
 
 # Build for an x86 glibc2-based Linux system:
+#SLKCFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS"
 CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
@@ -170,9 +185,9 @@
   --enable-64-bit-bfd \
   --enable-plugins \
   --enable-threads \
-  --enable-targets=i386-efi-pe,bpf-unknown-none,${TARGET} \
+  ${ADDTARGET} \
   --enable-install-libiberty \
-  --enable-gold=yes \
+  --enable-gold=$ENABLE_GOLD \
   --enable-ld=default \
   --enable-initfini-array \
   $WERROR \
diff -ur slackware64-current.2/source/d/cargo-vendor-filterer/cargo-vendor-filterer.SlackBuild slackware64-current.3/source/d/cargo-vendor-filterer/cargo-vendor-filterer.SlackBuild
--- slackware64-current.2/source/d/cargo-vendor-filterer/cargo-vendor-filterer.SlackBuild	2023-04-19 20:21:42.773010844 +0200
+++ slackware64-current.3/source/d/cargo-vendor-filterer/cargo-vendor-filterer.SlackBuild	2023-09-22 15:09:55.325656914 +0200
@@ -98,18 +98,60 @@
 directory = "vendor"
 EOF
 
+# rustix uses now by default linux_raw backend for syscalls, but seems supported only
+# for aarch64, arm, mipsel, mips64el, powerpc64le, riscv64, x86, and x86_64.
+# Re-add real errno for other architectures, or you can pass "--cfg=rustix_use_libc" 
+# to force libc usage.
+case "$ARCH" in
+  mips|ppc|ppc64|s390x|loongarch64) 
+    (cd vendor
+     rm -rf errno
+     tar xvf $CWD/errno-*.tar.lz
+     cd rustix
+     perl -n -e '
+       if(m/dependencies.libc_errno/) { $status=1; }
+       if($status && m/"0\.3\.1"/) {
+	 s/"0.3.1"/"0.3.3"/;
+	 $status=0;
+       }
+       print;
+     ' Cargo.toml > Cargo.toml.tmp
+     \mv Cargo.toml.tmp Cargo.toml
+     cat .cargo-checksum.json  | perl -e '($newck)=split(" ",$ARGV[0]);while(<STDIN>) { s/("Cargo.toml":)"(\S+?)"/$1"$newck"/; print;}' `sha256sum Cargo.toml` > .cargo-checksum.json.tmp
+     \mv .cargo-checksum.json.tmp .cargo-checksum.json
+    )
+    #SLKRUSTFLAGS="--cfg=rustix_use_libc"
+    ;;
+esac
+
+# Add support for EXT4 ioctl and FICLONE to loongarch64
+case "$ARCH" in
+  loongarch64|mips|ppc64|s390x) 
+    (cd vendor
+     cd rustix
+     zcat $CWD/rustix-syscall_loongarch64.diff.gz | patch -p3 --verbose
+     cat .cargo-checksum.json  | perl -e '($newck)=split(" ",$ARGV[0]);while(<STDIN>) { s|("src/backend/libc/io/syscalls.rs":)"(\S+?)"|$1"$newck"|; print;}' `sha256sum src/backend/libc/io/syscalls.rs` > .cargo-checksum.json.tmp
+     \mv .cargo-checksum.json.tmp .cargo-checksum.json
+    )
+  ;;
+esac
+
+# Support for Loongarch64 in linux-raw-sys was introduced in 0.3.2, but rustix 
+# targets version 0.1.2 (raised to 0.1.4). Replace version 0.1.4 with 0.4.3 and
+# fix rustix Cargo.toml. See https://github.com/sunfishcode/linux-raw-sys/issues/34
+
+RUSTFLAGS="$SLKRUSTFLAGS" \
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
 OPENSSL_NO_VENDOR=1 \
 cargo build \
   --offline \
   --release \
-  --target $ARCH-unknown-linux-gnu \
-  $NUMJOBS
+  $NUMJOBS || exit 1
 
 mkdir -p $PKG/usr/bin
-install -m 755 target/$ARCH-unknown-linux-gnu/release/cargo-vendor-filterer \
-  $PKG/usr/bin/
+install -m 755 target/release/cargo-vendor-filterer \
+  $PKG/usr/bin/ || exit 1
 
 find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
   | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
diff -ur slackware64-current.2/source/d/cbindgen/cbindgen.SlackBuild slackware64-current.3/source/d/cbindgen/cbindgen.SlackBuild
--- slackware64-current.2/source/d/cbindgen/cbindgen.SlackBuild	2021-09-09 19:19:52.527012986 +0200
+++ slackware64-current.3/source/d/cbindgen/cbindgen.SlackBuild	2021-09-18 13:42:54.186961238 +0200
@@ -104,12 +104,11 @@
 cargo build \
   --offline \
   --release \
-  --target $ARCH-unknown-linux-gnu \
   --verbose \
   $NUMJOBS || exit 1
 
 mkdir -p $PKG/usr/bin
-install -m 755 target/$ARCH-unknown-linux-gnu/release/cbindgen $PKG/usr/bin
+install -m 755 target/release/cbindgen $PKG/usr/bin || exit 1
 
 find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
   | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
diff -ur slackware64-current.2/source/d/clisp/clisp.SlackBuild slackware64-current.3/source/d/clisp/clisp.SlackBuild
--- slackware64-current.2/source/d/clisp/clisp.SlackBuild	2021-10-02 10:49:12.993388643 +0200
+++ slackware64-current.3/source/d/clisp/clisp.SlackBuild	2023-06-23 11:36:11.929328955 +0200
@@ -86,6 +86,9 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Disabled SPARCv8plus instructions (-mcpu=v9):
+sed -i 's/ -mcpu=v9//' configure
+
 CFLAGS="$SLKCFLAGS" \
 ./configure \
   --prefix=/usr \
diff -ur slackware64-current.2/source/d/cmake/cmake.SlackBuild slackware64-current.3/source/d/cmake/cmake.SlackBuild
--- slackware64-current.2/source/d/cmake/cmake.SlackBuild	2022-04-30 21:32:40.309799140 +0200
+++ slackware64-current.3/source/d/cmake/cmake.SlackBuild	2023-07-25 11:47:33.216720484 +0200
@@ -78,6 +81,7 @@
 cd cmake-build
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
   ../configure \
   --prefix=/usr \
   --docdir=/doc/$PKGNAM-$VERSION \
